## pam-0.79.tar.bz2

=== Linux-PAM/Makefile ===
##
## $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
##

## Note, ideally I would prefer it if this top level makefile did
## not get created by autoconf. As I find typing 'make' and relying
## on it to take care of all dependencies much more friendly than
## the multi-stage autoconf+make and also worry about updates to
## configure.in not getting propagated down the tree. (AGM) [I realise
## that this may not prove possible, but at least I tried.. Sigh.]

DISTNAME=Linux-PAM

-include Make.Rules

THINGSTOMAKE = libpam libpamc libpam_misc modules doc examples

all: $(THINGSTOMAKE)

 # Let's get a dynamic libpam.so first
 bootstrap-libpam: _pam_aconf.h prep
	$(MAKE) -C libpam bootstrap-libpam

prep:
	rm -f security
	ln -sf . security

clean:
	if [ ! -f Make.Rules ]; then touch Make.Rules ; fi
	for i in $(THINGSTOMAKE) ; do $(MAKE) -C $$i clean ; done
	rm -f security *~ *.orig *.rej #*#

distclean: clean
	rm -f Make.Rules _pam_aconf.h
	rm -f config.status config.cache config.log core
	rm -rf autom4te.cache/

maintainer-clean: distclean
	@echo files should be ok for packaging now.

# NB _pam_aconf.h.in changes will remake this too
Make.Rules: configure Make.Rules.in _pam_aconf.h.in
	./config.status --recheck
	./config.status

_pam_aconf.h: Make.Rules

configure: configure.in
	@echo
	@echo You do not appear to have an up-to-date ./configure file.
	@echo Please run autoconf, and then ./configure [..options..]
	@echo
	@rm -f configure
	@exit 1

$(THINGSTOMAKE): _pam_aconf.h prep bootstrap-libpam
	$(MAKE) -C $@ all

install: _pam_aconf.h prep
	for x in $(THINGSTOMAKE) ; do $(MAKE) -C $$x install ; done

remove:
	rm -f $(FAKEROOT)$(INCLUDED)/_pam_aconf.h
	for x in $(THINGSTOMAKE) ; do $(MAKE) -C $$x remove ; done

release:
	@if [ ! -f Make.Rules ]; then echo $(MAKE) Make.Rules first ;exit 1 ;fi
	@if [ ! -L ../$(DISTNAME)-$(MAJOR_REL).$(MINOR_REL) ]; then \
	   echo generating ../$(DISTNAME)-$(MAJOR_REL).$(MINOR_REL) link ; \
	   ln -sf $(DISTNAME) ../$(DISTNAME)-$(MAJOR_REL).$(MINOR_REL) ; \
	   echo to ../$(DISTNAME) . ; fi
	@diff ../$(DISTNAME)-$(MAJOR_REL).$(MINOR_REL)/Make.Rules Make.Rules
	$(MAKE) distclean
	cd .. ; tar zvfc $(DISTNAME)-$(MAJOR_REL).$(MINOR_REL).tar.gz \
		--exclude CVS --exclude .cvsignore --exclude '.#*' \
		$(DISTNAME)-$(MAJOR_REL).$(MINOR_REL)/*

=== Linux-PAM/conf/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
#

dummy:
	@echo "*** This is not a top level Makefile!"

##########################################################

all:
	$(MAKE) -C pam_conv1 all

install: $(FAKEROOT)$(CONFIGED)/pam.conf
	$(MAKE) -C pam_conv1 install

$(FAKEROOT)$(CONFIGED)/pam.conf: ./pam.conf
	bash -f ./install_conf

remove:
	rm -f $(FAKEROOT)$(CONFIGED)/pam.conf
	$(MAKE) -C pam_conv1 remove

check:
	bash -f ./md5itall

lclean:
	rm -f core *~ .ignore_age

clean: lclean
	$(MAKE) -C pam_conv1 clean

extraclean: lclean
	$(MAKE) -C pam_conv1 extraclean

=== Linux-PAM/doc/Makefile ===

### $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $

include ../Make.Rules

#######################################################

FILES=pam pam_appl pam_modules
FSRCS=pam.sgml pam_appl.sgml pam_modules.sgml

TEXTS=txts/pam.txt txts/pam_appl.txt txts/pam_modules.txt
HTMLS=html/pam.html html/pam_appl.html html/pam_modules.html
PSFILES=ps/pam.ps ps/pam_appl.ps ps/pam_modules.ps
PDFFILES=pdf/pam.pdf ps/pam_appl.pdf ps/pam_modules.pdf

MODULES=$(shell ls modules/*.sgml)

#######################################################

dummy:
	@echo "Making the documentation..."
	@$(MAKE) all

# note, at this time we don't include pdf files by default, but you
# can type make pdf in this directory and see what happens in the pdf
# subdirectory.

all: htmls texts postscript pdf

htmls: $(HTMLS)

$(HTMLS) : $(FSRCS)
ifeq ($(HAVE_SGML2HTML),yes)
	@for i in $(FILES) ; do \
	if [ ! -f "html/$$i.html" ] || [ "$$i.sgml" -nt "html/$$i.html" ]; \
	then \
		cd html ; sgml2html ../$$i ; \
		if [ $$? -ne 0 ]; then exit 1 ; fi ; \
		cd .. ; \
	fi ; \
	done
else
	@echo XXX - you do not have the sgml2html binary installed
endif

texts: $(TEXTS)

$(TEXTS) : $(FSRCS)
ifeq ($(HAVE_SGML2TXT),yes)
	@for i in $(FILES) ; do \
		if [ ! -f "txts/$$i.txt" ] \
				|| [ "$$i.sgml" -nt "txts/$$i.txt" ]; then \
			cd txts ; sgml2txt ../$$i ; cd .. ; \
		fi ; \
	done
else
	@echo XXX - you do not have the sgml2txt binary installed
endif

postscript: $(PSFILES)

$(PSFILES): $(FSRCS)
ifneq ($(PSER),)
	@for i in $(FILES) ; do \
	if [ ! -f "ps/$$i.ps" ] || [ "$$i.sgml" -nt "ps/$$i.ps" ]; then \
		cd ps ; $(PSER) ../$$i ; cd .. ; \
	fi ; \
	done
else
	@echo XXX - neither sgml2ps nor sgml2latex binaries are installed
endif

pdf: $(PDFFILES)

$(PDFFILES) : $(PSFILES)
ifeq ($(HAVE_PS2PDF),yes)
	@for i in $(FILES) ; do \
	if [ ! -f "pdf/$$i.pdf" ] || [ "ps/$$i.ps" -nt "ps/$$i.pdf" ]; then \
		ps2pdf ps/$$i.ps pdf/$$i.pdf ; \
	fi ; \
	done
else
	@echo XXX - ps2pdf is not installed
endif

pam.sgml: pam_source.sgml MODULES-SGML CREDITS
	@sed -e '/^<!\-\- insert\-file MODULES\-SGML \-\->/r MODULES-SGML' pam_source.sgml | sed -e '/^<!\-\- insert\-file CREDITS \-\->/r CREDITS' > pam.sgml

MODULES-SGML: $(MODULES)
	@echo 'Building module text from files in modules/*.sgml'
	@rm -f MODULES-SGML
	@echo '<!-- modules included:' > MODULES-SGML
	@ls modules/*.sgml >> MODULES-SGML
	@echo '  and that is all -->' >> MODULES-SGML
	@cat modules/*.sgml >> MODULES-SGML

extraclean: clean

remove:
	cd man && for file in *.3 ; do \
	  rm -f $(FAKEROOT)$(MANDIR)/man3/$$file ; \
	done
	cd man && for file in *.8 ; do \
	  rm -f $(FAKEROOT)$(MANDIR)/man8/$$file ; \
	done
	cd txts && for file in *.txt; do \
	  rm -f $(FAKEROOT)$(DOCDIR)/text/$$file ; \
	done
	cd ps && for file in *.ps; do \
	  rm -f $(FAKEROOT)$(DOCDIR)/ps/$$file  ; \
	done
	cd html && for file in *.html; do \
	  rm -f $(FAKEROOT)$(DOCDIR)/html/$$file ; \
	done

install: all
ifeq ($(HAVE_SGML2TXT),yes)
	mkdir -p $(FAKEROOT)$(DOCDIR)/text
	for file in txts/*.txt; do \
	  install -m 644 $$file $(FAKEROOT)$(DOCDIR)/text ; \
	done
endif
ifneq ($(PSER),)
	mkdir -p $(FAKEROOT)$(DOCDIR)/ps
	for file in ps/*.ps; do \
	  install -m 644 $$file $(FAKEROOT)$(DOCDIR)/ps  ; \
	done
ifeq ($(HAVE_PS2PDF),yes)
	mkdir -p $(FAKEROOT)$(DOCDIR)/pdf
	for file in pdf/*.pdf; do \
	  install -m 644 $$file $(FAKEROOT)$(DOCDIR)/pdf  ; \
	done
endif
endif
ifeq ($(HAVE_SGML2HTML),yes)
	mkdir -p $(FAKEROOT)$(DOCDIR)/html
	for file in html/*.html; do \
	  install -m 644 $$file $(FAKEROOT)$(DOCDIR)/html ; \
	done
endif
	mkdir -p $(FAKEROOT)$(MANDIR)/man3
	mkdir -p $(FAKEROOT)$(MANDIR)/man8
	for file in man/*.3 ; do \
	  install -m 644 $$file $(FAKEROOT)$(MANDIR)/man3 ; \
	done
	for file in man/*.8 ; do \
	  install -m 644 $$file $(FAKEROOT)$(MANDIR)/man8 ; \
	done

spec: specs/draft-morgan-pam.raw
	cd specs/formatter && $(MAKE)
	specs/formatter/padout < specs/draft-morgan-pam.raw > specs/draft-morgan-pam-current.txt

releasedocs: all spec
	tar zvfc Linux-PAM-$(MAJOR_REL).$(MINOR_REL)-docs.tar.gz \
	--exclude CVS --exclude .cvsignore --exclude '.#*' \
	html ps txts specs/draft-morgan-pam-current.txt

clean:
	rm -f *~ *.bak
	rm -f html/pam*.html
	rm -f man/*~
	rm -f $(TEXTS)
	rm -f $(PSFILES) ps/missfont.log
	rm -f pdf/*.pdf
	rm -f MODULES-SGML pam.sgml
	rm -f specs/draft-morgan-pam-current.txt
	$(MAKE) -C specs/formatter clean

=== Linux-PAM/dynamic/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
#

include ../Make.Rules

ifeq ($(WITH_LIBDEBUG),yes)
 LIBNAME=pamd
else
 LIBNAME=pam
endif
VERSION=.$(MAJOR_REL)
MODIFICATION=.$(MINOR_REL)

# ---------------------------------------------

dummy: ../Make.Rules all

# ---------------------------------------------

# dynamic library names

PAMSHOBJ = pam.so
PAMSHOBJMAJ = $(PAMSHOBJ)$(VERSION)

DLIBOBJECTS = pam.o

# ---------------------------------------------
## rules

all: dirs $(PAMSHOBJ) ../Make.Rules

dirs:
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) dynamic
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(MKDIR) static
endif

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

static/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

$(PAMSHOBJ): $(DLIBOBJECTS)
ifeq ($(USESONAME),yes)
	$(LD_L) $(SOSWITCH) $(PAMSHOBJMAJ) -o $@ $+ $(LINKLIBS)
else
	$(LD_L) -o $@ $(DLIBOBJECTS) $(LINKLIBS)
endif

install: all
	$(MKDIR) $(FAKEROOT)$(libdir)
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(INSTALL) -m $(SHLIBMODE) $(PAMSHOBJ) $(FAKEROOT)$(libdir)/$(PAMSHOBJ)
	$(LDCONFIG)
endif

remove:
	rm -f $(FAKEROOT)$(libdir)/$(LIBPAM)
	$(LDCONFIG)

clean:
	rm -f a.out core *~ static/*.o dynamic/*.o
	rm -f *.a *.o *.so ./include/security/*~
	if [ -d dynamic ]; then rmdir dynamic ; fi
	if [ -d static ]; then rmdir static ; fi

=== Linux-PAM/examples/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#

include ../Make.Rules

PROGS = blank xsh check_user
SRCS = blank.c xsh.c check_user.c
PROGSUID =

ifeq ($(WITH_LIBDEBUG),yes)
 LIBSUFFIX=d
else
 LIBSUFFIX=
endif

CFLAGS += -I$(absolute_srcdir)/libpam_misc/include

LOADLIBES = -L$(absolute_objdir)/libpam -L$(absolute_objdir)/libpamc \
    -L$(absolute_objdir)/libpam_misc -lpam -lpam_misc

ifeq ($(STATIC_LIBPAM),yes)
  ifneq ($(DYNAMIC),)
    CFLAGS += $(CC_STATIC)
    LOADLIBES += $(LIBDL)
  endif
endif

all: $(PROGS)

check_user: check_user.o
	$(CC) $(CFLAGS) -o $@ $< $(LOADLIBES)

blank: blank.o
	$(CC) $(CFLAGS) -o $@ $< $(LOADLIBES)

xsh: xsh.o
	$(CC) $(CFLAGS) -o $@ $< $(LOADLIBES)

clean:
	rm -f *.a *.so *.o *~ $(PROGS) $(PROGSUID)
	rm -f *.a *.out *.o *.so

# note, the programs are test programs, they should not be
# installed on your system!

install: all
	if [ -n "$(PROGS)" ]; then cp $(PROGS) ../bin ; fi
	if [ -n "$(PROGSUID)" ]; then \
		$(INSTALL) -m 4555 $(PROGSUID) ../bin ; fi

remove:
	cd ../bin ; rm -f $(PROGS) $(PROGSUID)
	for x in $(PROGS) $(PROGSUID) ; do rm -f ../bin/$$x ; done

=== Linux-PAM/libpam/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
#

include ../Make.Rules

# need to tell libpam about the default directory for PAMs
MOREFLAGS=-D"DEFAULT_MODULE_PATH=\"$(SECUREDIR)/\""

ifeq ($(WITH_LIBDEBUG),yes)
 LIBNAME=libpamd
 CFLAGS += -D"DEBUG"
 CFLAGS += -g
else
 LIBNAME=libpam
endif
ifeq ($(WITH_PRELUDE),yes)
 CFLAGS += -DPRELUDE -DLIBPRELUDE_CONFIG_PREFIX=\"`libprelude-config --prefix`\"
 LINKLIBS += -lprelude
endif
VERSION=.$(MAJOR_REL)
MODIFICATION=.$(MINOR_REL)

# ---------------------------------------------

dummy: ../Make.Rules all

# ---------------------------------------------

CFLAGS += $(DYNAMIC) $(STATIC) $(MOREFLAGS) \
  -DLIBPAM_VERSION_MAJOR=$(MAJOR_REL) \
  -DLIBPAM_VERSION_MINOR=$(MINOR_REL) \
  -DLIBPAM_VERSION_STRING=\"$(MAJOR_REL).$(MINOR_REL)\"

# dynamic library names

LIBPAM = $(LIBNAME).$(DYNTYPE)
LIBPAMNAME = $(LIBPAM)$(VERSION)
LIBPAMFULL = $(LIBPAMNAME)$(MODIFICATION)

# static library name

LIBPAMSTATIC = $(LIBNAME).a

ifdef STATIC
#	@echo Did you mean to set STATIC\?
MODULES = $(shell cat ../modules/_static_module_objects)
STATICOBJ = pam_static.o
else
MODULES =
endif

ifeq ($(WITH_MEMORY_DEBUG),yes)
EXTRAS += pam_malloc.o
endif

LIBOBJECTS = pam_item.o pam_strerror.o pam_end.o pam_start.o pam_data.o \
		pam_delay.o pam_dispatch.o pam_handlers.o pam_misc.o \
		pam_account.o pam_auth.o pam_prelude.o pam_session.o pam_password.o \
		pam_env.o pam_log.o $(EXTRAS)

ifeq ($(DYNAMIC_LIBPAM),yes)
# libpam.so needs -ldl, too.
DLIBOBJECTS = $(addprefix dynamic/,$(LIBOBJECTS) $(STATICOBJ))
ifeq ($(STATICOBJ),yes)
dynamic/pam_static.o: pam_static.c ../modules/_static_module_objects
	$(CC) $(CFLAGS) -c pam_static.c -o $@
endif
endif

ifeq ($(STATIC_LIBPAM),yes)
SLIBOBJECTS = $(addprefix static/,$(LIBOBJECTS) $(STATICOBJ))
ifdef STATICOBJ
static/pam_static.o: pam_static.c ../modules/_static_module_objects
	$(CC) $(CFLAGS) -c pam_static.c -o $@
endif
endif

# ---------------------------------------------
## rules

all: dirs $(LIBPAM) $(LIBPAMSTATIC) ../Make.Rules

dirs:
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) dynamic
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(MKDIR) static
endif

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

static/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@
bootstrap-libpam: bootdir $(LIBPAM)
bootdir:
	test -d dynamic || mkdir dynamic

$(LIBPAM): $(DLIBOBJECTS)
ifeq ($(DYNAMIC_LIBPAM),yes)
    ifeq ($(USESONAME),yes)
	$(LD_L) $(SOSWITCH)$(LIBPAMNAME) -o $@ $(DLIBOBJECTS) \
		$(MODULES) $(LINKLIBS)
    else
	$(LD_L) -o $@ $(DLIBOBJECTS) $(MODULES) $(LINKLIBS)
    endif
    ifeq ($(NEEDSONAME),yes)
	rm -f $(LIBPAMFULL)
	ln -sf $(LIBPAM) $(LIBPAMFULL)
	rm -f $(LIBPAMNAME)
	ln -sf $(LIBPAM) $(LIBPAMNAME)
    endif
endif

$(LIBPAMSTATIC): $(SLIBOBJECTS)
ifeq ($(STATIC_LIBPAM),yes)
	$(AR) cru $@ $(SLIBOBJECTS) $(MODULES)
ifdef RANLIB
	$(RANLIB) $@
endif
endif

install: all
	$(MKDIR) $(FAKEROOT)$(INCLUDED) $(FAKEROOT)$(libdir)
	$(INSTALL) -m 644 include/security/pam_appl.h $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/pam_modules.h $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/_pam_macros.h $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/_pam_types.h $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/_pam_compat.h $(FAKEROOT)$(INCLUDED)
ifdef MEMORY_DEBUG
	$(INSTALL) -m 644 include/security/pam_malloc.h $(FAKEROOT)$(INCLUDED)
endif
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(INSTALL) -m $(SHLIBMODE) $(LIBPAM) $(FAKEROOT)$(libdir)/$(LIBPAMFULL)
ifndef FAKEROOT
	$(LDCONFIG)
else
	$(LDCONFIG) -n $(FAKEROOT)$(libdir)
endif
  ifneq ($(DYNTYPE),"sl")
	( cd $(FAKEROOT)$(libdir) ; rm -f $(LIBPAM) ; \
	  ln -sf $(LIBPAMNAME) $(LIBPAM) )
  endif
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(INSTALL) -m 644 $(LIBPAMSTATIC) $(FAKEROOT)$(libdir)
endif

remove:
	rm -f $(FAKEROOT)$(INCLUDED)/_pam_types.h
	rm -f $(FAKEROOT)$(INCLUDED)/_pam_macros.h
	rm -f $(FAKEROOT)$(INCLUDED)/pam_appl.h
	rm -f $(FAKEROOT)$(INCLUDED)/pam_modules.h
	rm -f $(FAKEROOT)$(INCLUDED)/pam_malloc.h
	rm -f $(FAKEROOT)$(libdir)/$(LIBPAM).*
	rm -f $(FAKEROOT)$(libdir)/$(LIBPAM)
ifndef FAKEROOT
	$(LDCONFIG)
endif
	rm -f $(FAKEROOT)$(libdir)/$(LIBPAMSTATIC)

clean:
	rm -f a.out core *~ static/*.o dynamic/*.o
	rm -f *.orig $(LIBPAMNAME) $(LIBPAMFULL)
	rm -f *.a *.o *.so ./include/security/*~
	if [ -d dynamic ]; then rmdir dynamic ; fi
	if [ -d static ]; then rmdir static ; fi

=== Linux-PAM/libpam_misc/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#

# lots of debugging information goes to /tmp/pam-debug.log
#MOREFLAGS += -D"DEBUG"

include ../Make.Rules

ifeq ($(WITH_LIBDEBUG),yes)
 LIBNAME=libpam_miscd
else
 LIBNAME=libpam_misc
endif
ifeq ($(WITH_PRELUDE),yes)
 CFLAGS += -DPRELUDE -DLIBPRELUDE_CONFIG_PREFIX=\"`libprelude-config --prefix`\"
endif
VERSION=.$(MAJOR_REL)
MODIFICATION=.$(MINOR_REL)

CFLAGS += $(MOREFLAGS) $(DYNAMIC) $(STATIC)
LINKLIBS += -L$(absolute_objdir)/libpam -lpam

# dynamic library names

LIBNAMED = $(LIBNAME).$(DYNTYPE)
LIBNAMEDNAME = $(LIBNAMED)$(VERSION)
LIBNAMEDFULL = $(LIBNAMEDNAME)$(MODIFICATION)

# static library name

LIBNAMEDSTATIC = $(LIBNAME).a

LIBOBJECTS = help_env.o misc_conv.o

ifeq ($(DYNAMIC_LIBPAM),yes)
DLIBOBJECTS = $(addprefix dynamic/,$(LIBOBJECTS))
endif

ifeq ($(STATIC_LIBPAM),yes)
SLIBOBJECTS = $(addprefix static/,$(LIBOBJECTS))
endif

# ---------------------------------------------
## rules

all: dirs $(LIBNAMED) $(LIBNAMEDSTATIC)

dirs:
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) dynamic
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(MKDIR) static
endif

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

static/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

$(LIBNAMED): $(DLIBOBJECTS)
ifeq ($(DYNAMIC_LIBPAM),yes)
    ifeq ($(USESONAME),yes)
	$(LD_L) $(SOSWITCH)$(LIBNAMEDNAME) -o $@ $(DLIBOBJECTS) $(MODULES) $(LINKLIBS)
    else
	$(LD_L) -o $@ $(DLIBOBJECTS) $(MODULES) $(LINKLIBS)
    endif
    ifeq ($(NEEDSONAME),yes)
	rm -f $(LIBNAMEDFULL)
	ln -s $(LIBNAMED) $(LIBNAMEDFULL)
	rm -f $(LIBNAMEDNAME)
	ln -s $(LIBNAMED) $(LIBNAMEDNAME)
    endif
endif

$(LIBNAMEDSTATIC): $(SLIBOBJECTS)
ifeq ($(STATIC_LIBPAM),yes)
	$(AR) rcu $@ $(SLIBOBJECTS) $(MODULES)
ifdef RANLIB
	$(AR) rc $@ $(SLIBOBJECTS) $(MODULES)
	$(RANLIB) $@
endif
endif

install: all
	$(MKDIR) $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/pam_misc.h $(FAKEROOT)$(INCLUDED)
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) $(FAKEROOT)$(libdir)
	$(INSTALL) -m $(SHLIBMODE) $(LIBNAMED) $(FAKEROOT)$(libdir)/$(LIBNAMEDFULL)
ifndef FAKEROOT
	$(LDCONFIG)
else
	$(LDCONFIG) -n $(FAKEROOT)$(libdir)
endif
  ifneq ($(DYNTYPE),"sl")
	( cd $(FAKEROOT)$(libdir) ; rm -f $(LIBNAMED) ; ln -s $(LIBNAMEDNAME) $(LIBNAMED) )
  endif
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(INSTALL) -m 644 $(LIBNAMEDSTATIC) $(FAKEROOT)$(libdir)
endif

remove:
	rm -f $(FAKEROOT)$(INCLUDED)/pam_misc.h
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMEDFULL)
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMED)
ifndef FAKEROOT
	$(LDCONFIG)
endif
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMEDSTATIC)

clean:
	rm -f a.out core *~ static/*.o dynamic/*.o
	rm -f *.a *.out *.o *.so ./include/security/*~
	rm -f *.orig $(LIBNAMEDNAME) $(LIBNAMEDFULL)
	if [ -d dynamic ]; then rmdir dynamic ; fi
	if [ -d static ]; then rmdir static ; fi

=== Linux-PAM/libpamc/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#

# lots of debugging information goes to /tmp/pam-debug.log
#MOREFLAGS += -D"DEBUG"

include ../Make.Rules

ifeq ($(DEBUG_REL),yes)
 LIBNAME=libpamcd
else
 LIBNAME=libpamc
endif
ifeq ($(WITH_PRELUDE),yes)
 CFLAGS += -DPRELUDE -DLIBPRELUDE_CONFIG_PREFIX=\"`libprelude-config --prefix`\"
endif
VERSION=.$(MAJOR_REL)
MODIFICATION=.$(MINOR_REL)

CFLAGS += $(MOREFLAGS) $(DYNAMIC) $(STATIC)

# dynamic library names

LIBNAMED = $(LIBNAME).$(DYNTYPE)
LIBNAMEDNAME = $(LIBNAMED)$(VERSION)
LIBNAMEDFULL = $(LIBNAMEDNAME)$(MODIFICATION)

# static library name

LIBNAMEDSTATIC = $(LIBNAME).a

LIBOBJECTS = pamc_client.o pamc_converse.o pamc_load.o

ifeq ($(DYNAMIC_LIBPAM),yes)
DLIBOBJECTS = $(addprefix dynamic/,$(LIBOBJECTS))
endif

ifeq ($(STATIC_LIBPAM),yes)
SLIBOBJECTS = $(addprefix static/,$(LIBOBJECTS))
endif

# ---------------------------------------------
## rules

all: dirs $(LIBNAMED) $(LIBNAMEDSTATIC)

dirs:
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) dynamic
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(MKDIR) static
endif

dynamic/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

static/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@

$(LIBNAMED): $(DLIBOBJECTS)
ifeq ($(DYNAMIC_LIBPAM),yes)
    ifeq ($(USESONAME),yes)
	$(LD_L) $(SOSWITCH)$(LIBNAMEDNAME) -o $@ $(DLIBOBJECTS) $(MODULES) $(LINKLIBS)
    else
	$(LD_L) -o $@ $(DLIBOBJECTS) $(MODULES)
    endif
    ifeq ($(NEEDSONAME),yes)
	rm -f $(LIBNAMEDFULL)
	ln -s $(LIBNAMED) $(LIBNAMEDFULL)
	rm -f $(LIBNAMEDNAME)
	ln -s $(LIBNAMED) $(LIBNAMEDNAME)
    endif
endif

$(LIBNAMEDSTATIC): $(SLIBOBJECTS)
ifeq ($(STATIC_LIBPAM),yes)
	$(AR) rcu $@ $(SLIBOBJECTS) $(MODULES)
ifdef RANLIB
	$(RANLIB) $@
endif
endif

install: all
	$(MKDIR) $(FAKEROOT)$(INCLUDED)
	$(INSTALL) -m 644 include/security/pam_client.h $(FAKEROOT)$(INCLUDED)
ifeq ($(DYNAMIC_LIBPAM),yes)
	$(MKDIR) $(FAKEROOT)$(libdir)
	$(INSTALL) -m $(SHLIBMODE) $(LIBNAMED) $(FAKEROOT)$(libdir)/$(LIBNAMEDFULL)
ifndef FAKEROOT
	$(LDCONFIG)
else
	$(LDCONFIG) -n $(FAKEROOT)$(libdir)
endif
  ifneq ($(DYNTYPE),"sl")
	( cd $(FAKEROOT)$(libdir) ; rm -f $(LIBNAMED) ; ln -s $(LIBNAMEDNAME) $(LIBNAMED) )
  endif
endif
ifeq ($(STATIC_LIBPAM),yes)
	$(INSTALL) -m 644 $(LIBNAMEDSTATIC) $(FAKEROOT)$(libdir)
endif

remove:
	rm -f $(FAKEROOT)$(INCLUDED)/pam_client.h
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMEDFULL)
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMED)
ifndef FAKEROOT
	$(LDCONFIG)
endif
	rm -f $(FAKEROOT)$(libdir)/$(LIBNAMEDSTATIC)

clean:
	rm -f a.out core *~ static/*.o dynamic/*.o
	rm -f *.a *.out *.o *.so ./include/security/*~
	rm -f *.orig $(LIBNAMEDNAME) $(LIBNAMEDFULL)
	if [ -d dynamic ]; then rmdir dynamic ; fi
	if [ -d static ]; then rmdir static ; fi

=== Linux-PAM/modules/Makefile ===
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
# Makefile
#
# This makefile controls the build process of shared and static PAM modules.
#
#

include ../Make.Rules

MODDIRS=$(shell /bin/ls -d pam_*/Makefile | cut -f1 -d/)

all:	
	@echo building the static modutil library
	make -C pammodutil all
	@echo modules sources available are:
	@ls -d $(MODDIRS) 2>/dev/null ; echo :--------
	@echo
ifdef STATIC
	rm -f ./_static_module_*
endif
	@for i in $(MODDIRS) ; do \
		if [ -d $$i ]; then { \
		   $(MAKE) -C $$i all ; \
		   if [ $$? -ne 0 ]; then exit 1 ; fi ; \
		} elif [ -f ./.$$i ]; then { \
		   cat ./.$$i ; \
		} fi ; \
	done

download:
	@./download-all

install:
	for i in $(MODDIRS) ; do \
		if [ -d $$i ]; then { \
		$(MAKE) -C $$i install ; \
		if [ $$? -ne 0 ]; then exit 1 ; fi ; \
		} fi ; \
	done

remove:
	for i in $(MODDIRS) ; do \
		if [ -d $$i ]; then { \
			$(MAKE) -C $$i remove ; \
		} fi ; \
	done

lclean:
	rm -f _static_module_*

clean: lclean
	for i in $(MODDIRS) ; do \
		if [ -d $$i ]; then { \
			$(MAKE) -C $$i clean ; \
		} fi ; \
	done
	make -C pammodutil clean

=== Linux-PAM/conf/pam_conv1/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#

include ../../Make.Rules

#
ifeq ($(OS),solaris)

clean:
      @echo not available in Solaris

all:
      @echo not available in Solaris

install:
      @echo not available in Solaris

else

all: pam_conv1

pam_conv1: pam_conv.tab.c lex.yy.c
	$(CC) -o pam_conv1 $(CFLAGS) pam_conv.tab.c $(LINK_LIBLEX)

pam_conv.tab.c: pam_conv.y lex.yy.c
	bison pam_conv.y

lex.yy.c: pam_conv.lex
	flex pam_conv.lex

lclean:
	rm -f core pam_conv1 lex.yy.c pam_conv.tab.c *.o *~
	rm -rf ./pam.d pam_conv.output

clean: lclean

install: pam_conv1
	cp -f ./pam_conv1 ../../bin

endif

remove:
	rm -f ../../bin/pam_conv1

extraclean: remove clean

=== Linux-PAM/modules/pam_access/Makefile ===
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
# This Makefile controls a build process of $(TITLE) module for
# Linux-PAM. You should not modify this Makefile (unless you know
# what you are doing!).
#

include ../../Make.Rules

TITLE=pam_access
LOCAL_CONFILE=./access.conf
INSTALLED_CONFILE=$(SCONFIGD)/access.conf
ifeq ($(HAVE_LIBNSL),yes)
MODULE_SIMPLE_EXTRALIBS=-lnsl
endif

DEFS=-DDEFAULT_CONF_FILE=\"$(INSTALLED_CONFILE)\"
CFLAGS += $(DEFS)

MODULE_SIMPLE_INSTALL=bash -f ../install_conf "$(FAKEROOT)" "$(SCONFIGD)" "$(INSTALLED_CONFILE)" "$(TITLE)" "$(LOCAL_CONFILE)"
MODULE_SIMPLE_REMOVE=rm -f $(FAKEROOT)$(INSTALLED_CONFILE)
MODULE_SIMPLE_CLEAN=rm -f ./.ignore_age

include ../Simple.Rules

=== Linux-PAM/modules/pam_cracklib/Makefile ===
#
# $Id: Makefile 274 2005-07-13 09:52:25Z vorlon $
#
# This Makefile controls a build process of $(TITLE) module for
# Linux-PAM. You should not modify this Makefile (unless you know
# what you are doing!).
#
# Created by Andrew Morgan <morgan@kernel.org> 2000/10/08
#

include ../../Make.Rules

TITLE=pam_cracklib

ifeq ($(HAVE_LIBCRACK),yes)
BUILD_THIS_MODULE=yes
MODULE_SIMPLE_EXTRALIBS=-lcrack

# These two should really be provided by ../../pam_aconf.h
CFLAGS+=-DCRACKLIB_DICTPATH=\"$(CRACKLIB_DICTPATH)\"

ifeq ($(HAVE_LIBCRYPT),yes)
 MODULE_SIMPLE_EXTRALIBS += -lcrypt
endif

endif

ifeq ($(BUILD_THIS_MODULE),yes)
 include ../Simple.Rules
else
 include ../dont_makefile
endif

=== debian/changelog ===
pam (0.79-4) unstable; urgency=medium

  * Medium-urgency upload; at least one RC bugfix, but also a
    significant number of changes, hence not urgency=high.
  * Move libpam-modules and libpam0g to Section: libs and libpam-runtime
    to section: admin, to match the overrides in the archive.
  * Move old changelog entries (well, entry) that don't follow the current
    format to debian/changelog.old, since there's no way to figure out a
    timestamp for an 8-year-old upload, and this is the most effective
    way to clear a glut of lintian warnings.
  * Fix the formatting of the libpam-cracklib package description.
  * Patch 010: remove parts of the patch that aren't necessary for C++
    compatibility.
  * Patch 060: fix a segfault in pam_tally caused by misuse of
    pam_get_data(); already fixed upstream.  Closes: #335273.
  * Patch 061: fix a double free in pam_issue, caused by overuse (and misuse)
    of strdup (similar to patch 059).  Already fixed upstream.
    Closes: #327272.
  * Don't build-depend on libselinux1-dev and libcap-dev on kfreebsd archs.
    Closes: #352329.
  * Patch 005: sync pam_limits with upstream:
    - support "-" (unlimited) for all limit types except process priority.
    - support the additional aliases "-1", "unlimited", and "infinity" for
      clearing the limits; closes: #122400, #149027.
    - restrict the range of process priority, login count, and system login
      count settings to (INT_MIN,INT_MAX) (heh).
    - special-case RLIM_INFINITY when applying multipliers to values from
      the config.
    - document maxsyslogins in the default limits.conf; closes: #149883.
    - use the current process priority as a default instead of resetting to
      0; closes: #241663.
    - add support for (and document) new RLIMIT_NICE and RLIMIT_RTPRIO
      settings in Linux 2.6.12 and above; closes: #313542, #313588.
    - allow imposing limits on uid=0.
  * Patch 027: only set RLIM_INFINITY as the default for the limits where
    we know this is sensible, so that recompiling in an environment with new
    limits doesn't create a security hole -- as happened with RLIMIT_NICE and
    RLIMIT_RTPRIO!  Thanks to Ville Hallik for the initial patch.
    Closes: #388431.
  * Patch 029, 047: Fix up the broken pam_limits capabilities patch so it
    actually works -- which may well be a first...  Closes: #318452.

 -- Steve Langasek <vorlon@debian.org>  Mon, 23 Oct 2006 05:36:08 -0700

pam (0.79-3.2) unstable; urgency=low

  * Non-maintainer upload to fix important bug, that makes passwd segfault
    when CTRL-D is pressed at the password prompt.  Applied the patch 
    provided by Dann Frazier.  (Closes: #360657)

 -- Margarita Manterola <marga@debian.org>  Sat,  5 Aug 2006 02:11:22 -0300

pam (0.79-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Linux-PAM/libpamc/include/security/pam_client.h,
    Linux-PAM/libpamc/pamc_converse.c: Apply patch from
    latest upstream version to remove redefinition of internal
    glibc/libstdc++ types.  Closes: #344447.

 -- Roger Leigh <rleigh@debian.org>  Sun,  5 Feb 2006 21:46:59 +0000

pam (0.79-3) unstable; urgency=low

  * Patch 059
    - Fix a segfault in pam_userdb when the new "crypt=" option
      is unset, as will be the case for all existing users; already fixed
      upstream.  Closes: #330829.
    - Fix a memory leak in the same code due to gratuitous strdup()s.
  * Further regression in pam_env: don't treat a missing /etc/environment
    as a fatal error, either.  Amend patch 058 accordingly.  Closes: #330852.

 -- Steve Langasek <vorlon@debian.org>  Fri, 30 Sep 2005 01:17:53 -0700

pam (0.79-2) unstable; urgency=low

  The ".c.o: rm -rf $@" release
  * Fix debian/rules so that make clean doesn't remove ./configure when the
    timestamp on configure.in is newer (!).
  * Switch pam_userdb from db3 to db4.3, which according to the libdb
    maintainers should require no manual intervention for upgrading on-disk
    database formats.  Closes: #165068.
  * Patch 058:  yes, of course we want to read /etc/environment by
    default.  Grr!  Revert upstream change which disables this for no
    apparent reason (closes: #330458).
  * Tweak selinux rootok code to use the version of the function call that
    doesn't pollute namespace

 -- Steve Langasek <vorlon@debian.org>  Tue, 27 Sep 2005 02:44:36 -0700

pam (0.79-1) unstable; urgency=low

  * New upstream version (closes: #284954, #300775).
    - includes some fixes for typos (closes: #319026).
    - pam_unix should now be LSB 3.0-compliant (closes: #323982).
    - fixes segfaults in libpam on config file syntax errors
      (closes: #330097).
  * Drop patches 000_bootstrap, 004_libpam_makefile_static_works,
    011_pam_access, 013_pam_filter_termio_to_termios, 017_misc_fixes,
    025_pam_group_conffile_name, 028_pam_mail_delete_only_when_set,
    033_use_gcc_not_ld, 034_pam_dispatch_ignore_PAM_IGNORE,
    035_pam_unix_security, 039_pam_mkhomedir_no_maxpathlen_required,
    041_call_bootstrap, 042_pam_mkhomedir_dest_not_source_for_errors,
    051_32_bit_pam_lastlog_ll_time, and
    053_pam_unix_user_known_returns_user_unknown which have been
    integrated upstream.
  * Merge one last bit of patch 053 into patch 043, where it should have
    been in the first place
  * Patch 057: SELinux support:
    - add support to pam_unix for copying SELinux security contexts when
      writing out new passwd/shadow files and creating lockfiles
    - support calling unix_chkpwd if opening /etc/shadow fails due to
      SELinux permissions
    - allow unix_chkpwd to authenticate for any user when in an SELinux
      context (hurray!); we depend on SELinux policies to prevent the
      helper's use as a brute force tool
    - also support querying user expiration info via unix_chkpwd
    - misc cleanup: clean up file descriptors when invoking unix_chkpwd
      (closes: #248310)
    - make pam_rootok check the SELinux passwd class permissions, not just
      the uid


=== debian/control ===
Source: pam
Section: libs
Priority: optional
Uploaders: Karl Ramm <kcr@debian.org>, Steve Langasek <vorlon@debian.org>
Maintainer: Sam Hartman <hartmans@debian.org>
Standards-Version: 3.5.8
Build-Depends: cracklib2-dev (>= 2.7-9), bzip2, debhelper, patch, libdb4.3-dev, libcap-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !netbsd-i386], libselinux1-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64 !netbsd-i386]
Build-Depends-Indep: linuxdoc-tools, linuxdoc-tools-latex,  tetex-extra, groff, opensp

Package: libpam0g
Priority: required
Architecture: any
Conflicts: libpam0 (<= 0.56-2), libpam
Replaces: libpam0g-util
Depends: ${shlibs:Depends}, libpam-runtime
Suggests: libpam-doc
Description: Pluggable Authentication Modules library
 Contains the C shared library for Linux-PAM, a suite of shared
 libraries that enable the local system administrator to choose how
 applications authenticate users.  In other words, without rewriting
 or recompiling a PAM-aware application, it is possible to switch
 between the authentication mechanism(s) it uses.  One may entirely
 upgrade the local authentication system without touching the
 applications themselves.

Package: libpam-modules
Priority: required
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: libpam0g-modules (= 0.66-1), libpam-motd, libpam-mkhomedir, suidmanager (<< 0.50)
Replaces: libpam0g-util
Provides: libpam-motd, libpam-mkhomedir
Description: Pluggable Authentication Modules for PAM
 This package completes the set of modules for PAM. It includes the
  pam_unix_*.so module as well as some specialty modules.

Package: libpam-runtime
Section: admin
Priority: required
Architecture: all
Replaces: libpam0g-util, libpam0g-dev
Conflicts: libpam0g-util, libpam0g (<< 0.66-0)
Description: Runtime support for the PAM library
 Contains configuration files and  directories required for
 authentication  to work on Debian systems.  This package is required
 on almost all installations.

Package: libpam0g-dev
Section: libdevel
Priority: optional
Architecture: any
Depends: libpam0g (= ${Source-Version}), libc6-dev|libc-dev
Conflicts: libpam-dev, libpam-dbg
Replaces: libpam0g (<= 0.65)
Provides: libpam-dev
Description: Development files for PAM
 Contains C header files and development shared libraries libraries for
 libpam, the pluggable authentication modules, a suite of shared libraries
 that enable the local system administrator to choose how applications
 authenticate users.
 .
 PAM decouples applications from the authentication mechanism, making it
 possible to upgrade the authentication system without recompiling or
 rewriting the applications.

Package: libpam-cracklib
Priority: optional
Architecture: any
Replaces: libpam0g-cracklib
Depends: ${shlibs:Depends}, cracklib-runtime,  wordlist
Description: PAM module to enable cracklib support
 This package includes libpam_cracklib, a PAM module that tests
 passwords to make sure they are not too weak during password change.

Package: libpam-doc
Provides: pam-doc
Section: doc
Priority: optional
Architecture: all
Description: Documentation of PAM
 Contains documentation (in HTML, ASCII, and PostScript format) for
 libpam, the Pluggable Authentication Modules library, a suite of shared
 libraries that enable the local system administrator to choose how
 applications authenticate users.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independant
# package.

DH_COMPAT = 3
export DH_COMPAT

OS_CFLAGS	:= -g -D_GNU_SOURCE -D_REENTRANT -fPIC

ifeq (,$(findstring noopt, ${DEB_BUILD_OPTIONS}))
OS_CFLAGS += -O2
endif

LC_COLLATE=C
export LC_COLLATE

BUILD_TREE=Linux-PAM

pdoc=libpam-doc
d = $(shell pwd)/debian
dl = $(d)/local
i = install -p -m 0644
ie = install -p -m 0755

#version=${shell expr `pwd` : '.*-\([0-9.]*\)'}
#version_major=${shell expr `pwd` : '.*-\([0-9]*\).[0-9.]*'}

build:   build-stamp
build-stamp: configure-stamp
	dh_testdir

	# Compile everything else
	$(MAKE) -C $(BUILD_TREE) OS_CFLAGS="$(OS_CFLAGS)"

	touch build-stamp

configure: configure-stamp

configure-stamp:
	touch $(BUILD_TREE)/configure
	cd $(BUILD_TREE) && \
	./configure --sysconfdir=/etc --prefix=/usr --enable-static-libpam \
	--mandir=/usr/share/man --infodir=/usr/share/info --libdir=/lib \
	--sbindir=/sbin --enable-docdir=/usr/share/doc/libpam-doc \
	--with-mailspool=/var/mail
	touch configure-stamp


clean:
	dh_testdir
	dh_testroot
	touch $(BUILD_TREE)/configure
	-$(MAKE) -C $(BUILD_TREE) distclean
	rm -f build-stamp configure-stamp
	rm -f Linux-PAM/bin/[a-z]*
	dh_clean

# Build architecture-independent files here.
binary-indep: build $(dh_mak_deps)
	dh_testdir -i
	dh_testroot -i
	dh_clean -i -k
	dh_installdirs -i

	$(MAKE) -C $(BUILD_TREE) DIRS=doc

	cd $(BUILD_TREE)/doc && ( \
		$(i) *.sgml $(d)/$(pdoc)/usr/share/doc/$(pdoc)/sgml ; \
		$(i) ps/*.ps $(d)/$(pdoc)/usr/share/doc/$(pdoc)/ps ; \
		$(i) html/*.html $(d)/$(pdoc)/usr/share/doc/$(pdoc)/html ; \
		$(i) txts/*.txt $(d)/$(pdoc)/usr/share/doc/$(pdoc)/txt ; \
		$(i) modules/*.sgml $(d)/$(pdoc)/usr/share/doc/$(pdoc)/sgml/modules )

	mkdir -p debian/tmp/etc/pam.d
	mkdir -p debian/tmp/usr/share/pam
	$(i) $(dl)/pam.conf $(d)/tmp/etc
	-mkdir -p $(d)/tmp/usr/sbin $(d)/tmp/usr/share/man/man8
	$(ie) $(dl)/pam_getenv $(d)/tmp/usr/sbin
	pod2man --section 8 --release="Debian GNU/Linux" $(dl)/pam_getenv >$(d)/tmp/usr/share/man/man8/pam_getenv.8
	$(i) $(dl)/other $(d)/tmp/etc/pam.d
	$(i) $(dl)/common-* $(d)/tmp/usr/share/pam/
	$(i) $(dl)/pam-*-guide $(d)/$(pdoc)/usr/share/doc-base/

	dh_movefiles -i

	dh_installman -plibpam-runtime $(BUILD_TREE)/doc/man/*.[578]
	rm  debian/libpam-runtime/usr/share/man/man8/{pam.8,pam.d.8,pam.conf.8}
	dh_installdocs -i
	dh_installchangelogs -i $(BUILD_TREE)/CHANGELOG
	dh_compress -i -X.html
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: build module_check $(dh_mak_deps)
	dh_testdir -a
	dh_testroot -a
	dh_clean -a -k
	dh_installdirs -a

	$(MAKE) install -C $(BUILD_TREE) FAKEROOT=$(d)/tmp \
		DIRS="libpam libpam_misc modules libpamc"
	mkdir -p debian/tmp/etc/pam.d
	$(i) $(dl)/pam.conf $(d)/tmp/etc
	$(i) $(dl)/other $(d)/tmp/etc/pam.d
	$(ie) -D  $(BUILD_TREE)/modules/pam_tally/pam_tally $(d)/tmp/usr/sbin/pam_tally
	$(i) $(dl)/unix_chkpwd.8 $(d)/libpam-modules/usr/share/man/man8
	mkdir -p debian/tmp/usr/lib
	mv debian/tmp/lib/*.a debian/tmp/usr/lib
	dh_movefiles  -plibpam0g-dev -plibpam-cracklib -plibpam0g
	dh_movefiles -plibpam-modules `cd $(d)/tmp && ls lib/security/*.so`
	dh_link -A
	dh_installman -plibpam0g-dev $(BUILD_TREE)/doc/man/*.3
	for manpage in pam_end pam_close_session pam_get_item; do \
	rm debian/libpam0g-dev/usr/share/man/man3/$$manpage.3; done


	dh_installdocs -a $(BUILD_TREE)/README
	$(i) $(dl)/Debian-PAM-MiniPolicy $(d)/libpam0g/usr/share/doc/libpam0g
	dh_installexamples -a
	dh_installcron -a

	dh_installchangelogs -a $(BUILD_TREE)/CHANGELOG
	dh_strip -a
	dh_compress -a
	dh_fixperms -Xunix_chkpwd -a
	dh_makeshlibs -plibpam0g -V "libpam0g (>= 0.76)"
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

module_check:
	for module in `ls build-tree/Linux-PAM-*/modules/pam_*/pam_*.so`; \
	do \
		test=`ldd $$module | grep libpam.so.0`; \
		if [ "x$$test" = "x" ]; then \
			echo $$module is not linked to libpam; \
			exit 1; \
		fi; \
	done

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
